<template>
  <div
    data-component="enhanced-editor"
    :class="getComponentClass()"
  >
    <div
      v-if="hasLabel"
      class="label"
    >
      {{ label }}
    </div>
    <base-text-editor
      :value="value"
      :config="config"
      :height="height"
      :disabled="disabled"
      @input="onChange"
      @tbw-blur="onBlur"
      @tbw-focus="onFocus"
    />
    <div
      v-if="hasErrors"
      class="error-message"
    >
      {{ errorMessage }}
    </div>
  </div>
</template>

<script>
  export default {
    props: {
      value: {
        default: null,
        required: true,
        validator(value) {
          return value === null
            || typeof value === 'string'
            || value instanceof String;
        }
      },
      config: {
        type: Object,
        default: () => ({})
      },
      height: {
        type: Number,
        default: 300
      },
      label: {
        type: String,
        default: ''
      },
      errorMessages: {
        type: Array,
        default() {
          return [];
        }
      },
      disabled: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        isFocused: false
      };
    },
    computed: {
      hasErrors() {
        return this.errorMessages.length > 0;
      },
      errorMessage() {
        return this.errorMessages[0];
      },
      hasLabel() {
        return this.label !== '';
      }
    },
    methods: {
      onChange(value) {
        this.$emit('input', value);
      },
      onBlur() {
        this.$emit('blur');
        this.isFocused = false;
      },
      onFocus() {
        this.$emit('focus');
        this.isFocused = true;
      },
      getComponentClass() {
        return {
          'v-text-field': true,
          'v-input--has-state': true,
          'error--text': this.hasErrors,
          'v-input--is-focused': this.isFocused
        };
      }
    }
  };
</script>

<style lang="stylus">
  @import '../assets/stylus/theme.styl';

  [data-component="enhanced-editor"] {
    position: relative;
    margin: 17px 0;

    [data-component="text-editor"] {
      &:after {
        content: '';
        position: absolute;
        bottom: 0;
        left: 0;
        width: 100%;
        transform: scaleX(0);
        height: 1px;
        background-color: $colors.error;
        transition: 0.15s ease-in-out;
      }
    }

    &.error--text {
      [data-component="text-editor"] {
        &:after {
          transform: scaleX(1);
          transition: 0.15s ease-in-out;
        }
      }
    }

    .label {
      margin: 0 0 -10px 0;
      font-size: 13px;
    }

    .error-message {
      margin: -14px 0 17px 0;
      color: $colors.error;
      font-size: 13px;
    }
  }
</style>
